
export type Stat = "AGI" | "INT" | "CHA" | "PSI";
export const ALL_STATS: Array<Stat> = ["AGI", "INT", "CHA", "PSI"];

export type Resource = "EXP";
export const ALL_RESOURCES: Array<Resource> = ["EXP"]

export type SkillGoverning = {
  stats: Stat[],
  underTarget: number,
  target: number,
  cost: number,
  note: string,
  scoring: SkillScoring,
};
export type SkillProfile = {
  name: string,
  description: string,
}

export type SkillData = {
  governing: SkillGoverning,
  profile: SkillProfile,
  prereqs: Skill[]
}

export type ScoringCategory = "bat" | "stealth" | "charm" | "stare" | "party" | "lore";
export const SCORING_CATEGORIES: ScoringCategory[] = ["bat", "stealth", "charm", "stare", "party", "lore"];
export type SkillScoring = {[P in ScoringCategory]?: number};

export type Skill = {
  id: number
}
