import {getPlayerProgress} from "./playerprogress.ts";
import {getHuntMode} from "./huntmode.ts";
import {getSleepModal} from "./sleepmodal.ts";
import {getEndgameModal} from "./vnmodal.ts";
import {getScorer} from "./scorer.ts";

const N_TURNS: number = 9;

export class StateManager {
  #turn: number;

  constructor() {
    this.#turn = 1;
  }

  getTurn(): number {
    return this.#turn
  }

  advance() {
    this.#turn += 1;

    if (this.#turn <= N_TURNS) {
      getPlayerProgress().refill();
      getHuntMode().replaceMap();
      getSleepModal().setShown(false);
    } else {
      // TODO: Play a specific scene
      let ending = getScorer().pickEnding();
      getEndgameModal().play(ending.scene);
    }
  }

  getMaxTurns() {
    return N_TURNS
  }
}

let active: StateManager = new StateManager();
export function getStateManager(): StateManager {
  return active
}